//========================================================================================
//
//	File:				SLWindow.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLWINDOW_H
#define SLWINDOW_H

#ifndef FWODTYPS_H
#include "FWODTyps.h"
#endif

#ifndef FWWINDOW_K
#include "FWWindow.k"
#endif

#ifndef SLPTRECT_H
#include "SLPtRect.h"
#endif

#ifndef SLSTRREP_H
#include "SLStrRep.h"
#endif

// ----- OpenDoc Includes -----

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

//========================================================================================
// External procedure definitions
//========================================================================================

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_EXTERN_C_BEGIN

//----------------------------------------------------------------------------------------
//	Public API
//
void SL_API					FW_PositionModalDialog(ODPlatformWindow platformWindow, 
								FW_PlatformError* error);

FW_Boolean SL_API			FW_FitWindowToScreen(ODPlatformWindow platformWindow, 
								FW_PlatformError* error);

void SL_API					FW_SetWindowSize(ODPlatformWindow platformWindow,
								const FW_SPoint& interiorSize,
								FW_PlatformError* error);
void SL_API					FW_SetWindowPosition(ODPlatformWindow platformWindow,
								const FW_SPoint& newPosition, 
								FW_PlatformError* error);

void SL_API					FW_GetWindowSize(ODPlatformWindow platformWindow,
								FW_SPoint& interiorSize, 
								FW_PlatformError* error);
void SL_API					FW_GetWindowPosition(ODPlatformWindow platformWindow,
								FW_SPoint& position, 
								FW_PlatformError* error);

void SL_API					FW_SetWindowTitle(ODPlatformWindow platformWindow, 
								FW_HString windowTiltle, 
								FW_PlatformError* error);								
void SL_API					FW_GetWindowTitle(ODPlatformWindow platformWindow, 
								FW_HString* windowTiltle, 
								FW_PlatformError* error);

void SL_API					FW_GetWindowBorderSize(ODPlatformWindow platformWindow,
								FW_SRect& borderSize,
								FW_PlatformError* error);
	
FW_PlatformError SL_API		FW_ScreenToWindow(ODPlatformWindow platformWindow,
								FW_SPoint* points, 
								unsigned short nbPoint);								
FW_PlatformError SL_API		FW_WindowToScreen(ODPlatformWindow platformWindow,
								FW_SPoint* points, 
								unsigned short nbPoint);
								
//----------------------------------------------------------------------------------------
//	Mac Specific API
//
#ifdef FW_BUILD_MAC	
// ----- Mac Window resizing tracking -----
FW_Boolean SL_API			FW_PrivMacTrackResizeWindow(ODPlatformWindow platformWindow, 
								const FW_SRect& growLimits, 
								FW_SPlatformPoint startPoint, 
								FW_PlatformError* error);
								
void SL_API					FW_PrivMacDoZoom(ODPlatformWindow platformWindow, 
								const FW_SPoint& zoomedSize, 
								const FW_SRect& borderSize,
								const FW_SRect& screenRect,
								unsigned long message, 
								FW_PlatformError* error);
								
// ----- Mac Window creation -----
ODPlatformWindow SL_API		FW_PrivMacCreatePlatformWindow(Environment* ev, 
								Str255 windowTitle,
								const FW_SPoint& interiorSize,
								const FW_SPoint& position,
								unsigned short procID,
								FW_Boolean hasCloseBox,
								long refCon);

unsigned short SL_API 		FW_PrivMacStyleToProcId(FW_WindowStyle style);
#endif

//----------------------------------------------------------------------------------------
//	Windows Specific API
//
#ifdef FW_BUILD_WIN
DWORD SL_API				FW_PrivWindStyleToWindowsFlags(FW_WindowStyle style);
void  SL_API				FW_PrivWindFixSystemMenu(FW_WindowStyle style);
#endif

FW_EXTERN_C_END

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

#endif
